"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class SamtoolsStatsCalculations(ProtocolElement):
    """
    Stats calculated from values stored in SamtoolsStats
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "SAMTOOLS_PAIRS_ON_DIFFERENT_CHROMOSOMES_PERCENT",
        "SAMTOOLS_READS_MAPPED_PERCENT",
        "samtoolsScope",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_6 import metrics as metrics_1_2_4

        return {
            "samtoolsScope": metrics_1_2_4.SamtoolsScope,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_6 import metrics as metrics_1_2_4

        return {
            "org.gel.models.report.avro.SamtoolsScope": metrics_1_2_4.SamtoolsScope,
            "org.gel.models.report.avro.SamtoolsStatsCalculations": metrics_1_2_4.SamtoolsStatsCalculations,
        }

    __slots__ = [
        "SAMTOOLS_PAIRS_ON_DIFFERENT_CHROMOSOMES_PERCENT",
        "SAMTOOLS_READS_MAPPED_PERCENT",
        "samtoolsScope",
    ]

    def __init__(
        self,
        SAMTOOLS_PAIRS_ON_DIFFERENT_CHROMOSOMES_PERCENT,
        SAMTOOLS_READS_MAPPED_PERCENT,
        samtoolsScope,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_4.SamtoolsStatsCalculations model.

        :param SAMTOOLS_PAIRS_ON_DIFFERENT_CHROMOSOMES_PERCENT:
            Percentage of chimeric reads
        :type SAMTOOLS_PAIRS_ON_DIFFERENT_CHROMOSOMES_PERCENT: double
        :param SAMTOOLS_READS_MAPPED_PERCENT:
            Percentage of mapped reads
        :type SAMTOOLS_READS_MAPPED_PERCENT: double
        :param samtoolsScope:
            Scope
        :type samtoolsScope: SamtoolsScope
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.4"
